searchNodes=[{"doc":"This is the module providing the OpenTelemetry protocol for exporting traces. It can be configured through its application environment, the OS environment or directly through a map of options passed when setting up the exporter in the batch processor. opentelemetry_exporter application environment options are: otlp_endpoint : The URL to send traces and metrics to, for traces the path v1/traces is appended to the path in the URL. otlp_traces_endpoint : URL to send only traces to. This takes precedence for exporting traces and the path of the URL is kept as is, no suffix is appended. otlp_headers : List of additional headers ( [{unicode:chardata(), unicode:chardata()}] ) to add to export requests. otlp_traces_headers : Additional headers ( [{unicode:chardata(), unicode:chardata()}] ) to add to only trace export requests. otlp_protocol : The transport protocol, supported values: grpc and http_protobuf . Defaults to http_protobuf . otlp_traces_protocol : The transport protocol to use for exporting traces, supported values: grpc and http_protobuf . Defaults to http_protobuf otlp_compression : Compression type to use, supported values: gzip . Defaults to no compression. otlp_traces_compression : Compression type to use for exporting traces, supported values: gzip . Defaults to no compression. There also corresponding OS environment variables can also set those configuration values: OTEL_EXPORTER_OTLP_ENDPOINT : The URL to send traces and metrics to, for traces the path v1/traces is appended to the path in the URL. OTEL_EXPORTER_OTLP_TRACES_ENDPOINT : URL to send only traces to. This takes precedence for exporting traces and the path of the URL is kept as is, no suffix is appended. OTEL_EXPORTER_OTLP_HEADERS : List of additional headers to add to export requests. OTEL_EXPORTER_OTLP_TRACES_HEADERS : Additional headers to add to only trace export requests. OTEL_EXPORTER_OTLP_PROTOCOL : The transport protocol to use, supported values: grpc and http_protobuf . Defaults to http_protobuf . OTEL_EXPORTER_OTLP_TRACES_PROTOCOL : The transport protocol to use for exporting traces, supported values: grpc and http_protobuf . Defaults to http_protobuf . OTEL_EXPORTER_OTLP_COMPRESSION : Compression to use, supported value: gzip. Defaults to no compression. OTEL_EXPORTER_OTLP_TRACES_COMPRESSION : Compression to use when exporting traces, supported value: gzip. Defaults to no compression. You can also set these configuration values in the map passed to the opentelemetry processor configuration. endpoints : A list of endpoints to send traces to. Can take one of the forms described below. By default, exporter sends data to http://localhost:4318 . headers : List of additional headers to add to export requests. protocol : The transport protocol to use, supported values: grpc and http_protobuf . Defaults to http_protobuf . compression : Compression to use, supported value: gzip . Defaults to no compression. ssl_options : a list of SSL options. See Erlang's SSL docs for what options are available. Endpoints configuration You can pass your collector endpoints in three forms: As a string, i.e &quot;https://localhost:4000&quot; . As a map, with the following keys: host =&gt; unicode:chardata() path =&gt; unicode:chardata() port =&gt; integer() &gt;= 0 | undefined scheme =&gt; unicode:chardata() As a 4 element tuple in format {Scheme, Host, Port, SSLOptions} . While using http_protobuf protocol, currently only the first endpoint in that list is used to export traces, the rest is effectively ignored. grpc supports multiple endpoints.","ref":"opentelemetry_exporter.html","title":"opentelemetry_exporter","type":"module"},{"doc":"Export OTLP protocol telemery data to the configured endpoints.","ref":"opentelemetry_exporter.html#export/3","title":"opentelemetry_exporter.export/3","type":"function"},{"doc":"Initialize the exporter based on the provided configuration.","ref":"opentelemetry_exporter.html#init/1","title":"opentelemetry_exporter.init/1","type":"function"},{"doc":"Shutdown the exporter.","ref":"opentelemetry_exporter.html#shutdown/1","title":"opentelemetry_exporter.shutdown/1","type":"function"},{"doc":"","ref":"opentelemetry_exporter.html#t:compression/0","title":"opentelemetry_exporter.compression/0","type":"type"},{"doc":"","ref":"opentelemetry_exporter.html#t:endpoint/0","title":"opentelemetry_exporter.endpoint/0","type":"type"},{"doc":"","ref":"opentelemetry_exporter.html#t:endpoint_map/0","title":"opentelemetry_exporter.endpoint_map/0","type":"type"},{"doc":"","ref":"opentelemetry_exporter.html#t:headers/0","title":"opentelemetry_exporter.headers/0","type":"type"},{"doc":"","ref":"opentelemetry_exporter.html#t:host/0","title":"opentelemetry_exporter.host/0","type":"type"},{"doc":"","ref":"opentelemetry_exporter.html#t:opts/0","title":"opentelemetry_exporter.opts/0","type":"type"},{"doc":"","ref":"opentelemetry_exporter.html#t:protocol/0","title":"opentelemetry_exporter.protocol/0","type":"type"},{"doc":"","ref":"opentelemetry_exporter.html#t:scheme/0","title":"opentelemetry_exporter.scheme/0","type":"type"},{"doc":"Client module for grpc service opentelemetry.proto.collector.trace.v1.TraceService.","ref":"opentelemetry_trace_service.html","title":"opentelemetry_trace_service","type":"module"},{"doc":"Unary RPC","ref":"opentelemetry_trace_service.html#export/1","title":"opentelemetry_trace_service.export/1","type":"function"},{"doc":"","ref":"opentelemetry_trace_service.html#export/2","title":"opentelemetry_trace_service.export/2","type":"function"},{"doc":"","ref":"opentelemetry_trace_service.html#export/3","title":"opentelemetry_trace_service.export/3","type":"function"},{"doc":"The OpenTelemetry Protocol exporter for use with the OpenTelemetry Collector . The version of this Application does not track the supported version of the OpenTelemetry Protocol (OTLP). The currently used version of the OTLP protobufs is v0.11.0 . Currently only supports the Tracer protocol using either GRPC or Protobuffers over HTTP1.1.","ref":"readme.html","title":"opentelemetry_exporter","type":"extras"},{"doc":"By default the exporter will use HTTP to export protobuf encoded Spans to http://localhost:4318/v1/traces . Available configuration keys: otlp_endpoint : The URL to send traces and metrics to, for traces the path v1/traces is appended to the path in the URL. otlp_traces_endpoint : URL to send only traces to. This takes precedence for exporting traces and the path of the URL is kept as is, no suffix is appended. otlp_headers : List of additional headers ( [{unicode:chardata(), unicode:chardata()}] ) to add to export requests. otlp_traces_headers : Additional headers ( [{unicode:chardata(), unicode:chardata()}] ) to add to only trace export requests. otlp_protocol : The transport protocol, supported values: grpc and http_protobuf . Defaults to http_protobuf . otlp_traces_protocol : The transport protocol to use for exporting traces, supported values: grpc and http_protobuf . Defaults to http_protobuf . otlp_compression : Compression type to use, supported values: gzip . Defaults to no compression. otlp_traces_compression : Compression type to use for exporting traces, supported values: gzip . Defaults to no compression. { opentelemetry_exporter , [ { otlp_protocol , grpc } , { otlp_compression , gzip } , { otlp_endpoint , &quot;https://api.honeycomb.io:443&quot; } , { otlp_headers , [ { &quot;x-honeycomb-dataset&quot; , &quot;experiments&quot; } ] } ] } An Elixir release uses releases.exs : config :opentelemetry_exporter , otlp_protocol : :grpc , otlp_compression : :gzip , otlp_endpoint : &quot;https://api.honeycomb.io:443&quot; , otlp_headers : [ { &quot;x-honeycomb-dataset&quot; , &quot;experiments&quot; } ] The default SSL options for HTTPS requests are set using tls_certificate_check . This package also provides the CA certificates from Mozilla . The user can override these options either as part of the endpoint or for all endpoints used by the exporter with the Application environment variable ssl_options See secure coding with inets for more information on securing HTTP requests in Erlang. OS Environment Lastly, configuring the exporter can be done with OS environment variables, which take precedence: OTEL_EXPORTER_OTLP_ENDPOINT : The URL to send traces and metrics to, for traces the path v1/traces is appended to the path in the URL. OTEL_EXPORTER_OTLP_TRACES_ENDPOINT : URL to send only traces to. This takes precedence for exporting traces and the path of the URL is kept as is, no suffix is appended. OTEL_EXPORTER_OTLP_HEADERS : List of additional headers to add to export requests. OTEL_EXPORTER_OTLP_TRACES_HEADERS : Additional headers to add to only trace export requests. OTEL_EXPORTER_OTLP_PROTOCOL : The transport protocol to use, supported values: grpc and http_protobuf . Defaults to http_protobuf OTEL_EXPORTER_OTLP_TRACES_PROTOCOL : The transport protocol to use for exporting traces, supported values: grpc and http_protobuf . Defaults to http_protobuf . OTEL_EXPORTER_OTLP_COMPRESSION : Compression to use, supported value: gzip. Defaults to no compression. OTEL_EXPORTER_OTLP_TRACES_COMPRESSION : Compression to use when exporting traces, supported value: gzip. Defaults to no compression. Example usage of setting the environment variables: OTEL_EXPORTER_OTLP_TRACES_ENDPOINT = https :// api . honeycomb . io : 443 OTEL_EXPORTER_OTLP_TRACES_PROTOCOL = grpc OTEL_EXPORTER_OTLP_TRACES_COMPRESSION = gzip OTEL_EXPORTER_OTLP_TRACES_HEADERS = x - honeycomb - team = &lt; HONEYCOMB API TOKEN &gt; , x - honeycomb - dataset = experiments Options to span processor In addition to using the environment variables the exporter accepts a map of arguments. The argument to the exporter's init function can be configured as part of the Span Processor (simple or batch) in the OpenTelemetry application environment. For an Erlang release in sys.config : { opentelemetry , [ { processors , [ { otel_batch_processor , \#{ exporter =&gt; { opentelemetry_exporter , \#{ endpoints =&gt; [ &quot;http://localhost:9090&quot; ] , headers =&gt; [ { &quot;x-honeycomb-dataset&quot; , &quot;experiments&quot; } ] } } } } ] } ] } The default protocol is http_protobuf , to override this and use grpc add protocol to the config map: { opentelemetry , [ { processors , [ { otel_simple_processor , \#{ exporter =&gt; { opentelemetry_exporter , \#{ protocol =&gt; grpc , endpoints =&gt; [ &quot;http://localhost:9090&quot; ] , headers =&gt; [ { &quot;x-honeycomb-dataset&quot; , &quot;experiments&quot; } ] } } } } ] } ] } In Elixir, you can use config.exs or runtime.exs : config :opentelemetry , :processors , otel_batch_processor : %{ exporter : { :opentelemetry_exporter , %{ endpoints : [ &quot;http://localhost:9090&quot; ] , headers : [ { &quot;x-honeycomb-dataset&quot; , &quot;experiments&quot; } ] } } } The configuration map The second element of the configuration tuple is a configuration map. It can contain the following keys: protocol - one of: http_protobuf , grpc or http_json . Defaults to http_protobuf . http_json is not implemented yet. endpoints - A list of endpoints to send traces to. Can take one of the forms described below. By default, exporter sends data to http://localhost:4318 . headers - a list of headers to send to the collector (i.e [{&lt;&lt;&quot;x-access-key&quot;&gt;&gt; &lt;&lt;&quot;secret&quot;&gt;&gt;}] ). Defaults to an empty list. compression - an atom. Setting it to gzip enables gzip compression. ssl_options - a list of SSL options. See Erlang's SSL docs for what options are available.","ref":"readme.html#configuration","title":"opentelemetry_exporter - Configuration","type":"extras"},{"doc":"This project uses a submodule during development, it is not needed if the application is being used as a dependency, so be sure to clone with the option recurse-submodules : $ git clone --recurse-submodules https://github.com/opentelemetry-beam/opentelemetry_exporter Upgrading OpenTelemetry Protos The protos are in a separate repository, opentelemetry-proto , and used as a submodule in this repo. To update the Erlang protobuf modules and GRPC client first update the submodule and then use the rebar3 grpcbox plugin to generate the client: $ git submodule update --remote opentelemetry-proto $ rebar3 grpc gen -t client ===&gt; Writing src/trace_service_pb.erl ===&gt; Writing src/opentelemetry_proto_collector_trace_v_1_trace_service_client.erl (forcibly overwriting) $ mv src/opentelemetry_proto_collector_trace_v_1_trace_service_client.erl src/opentelemetry_trace_service.erl Then open src/opentelemetry_trace_service.erl and fix the module name.","ref":"readme.html#contributing","title":"opentelemetry_exporter - Contributing","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]